'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'//+--------------------------------------------------------------------------+
'//|                               ChartSpec                                  |
'//|                                                                          |
'//|     Example using the OpenGL 3D chart primitives built into GDImage.     |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                         Author Patrice TERRIER                           |
'//|                                                                          |
'//|                           copyright (c) 2013                             |
'//|                                                                          |
'//|                Patrice Terrier http://www.zapsolution.com                |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                  Project started on : 12-24-2005 (MM-DD-YYYY)            |
'//|                        Last revised : 10-29-2013 (MM-DD-YYYY)            |
'//+--------------------------------------------------------------------------+
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Ported to bc9Basic by James C. Fuller just to see if I could.
'This source is not translatable with the current bc9Basic. A new version is in
'the works.
'bc9Basic will treat // as a comment but my editors syntax for comments does not
'so I added the ' so my comments would be green.
'I have NEVER put multiple statements on a single line even though bc9Basic will
'allow it.
'I wrapped several areas with $CCODE/$CCODE so I did not have to rewrite.
'another advantage when porting code.
'bc9Basic does not have the standard switch/case construct. Although it does have
'a very good SELECT CASE it does not translate to switch/case. I find switch/case
'useful in some situations so again by the magic of $CCODE/$CCODE .....
' I can handle a few ";"
' Needed to change UBOUND to _UBOUND
'Removed all the "L" because a post unicode translation adds _T()
'Local Dimming auto adds = {0}
'The UNICODE AWARE are to tell the unicode lexer to ignore code beween .
'Raw is a dimensioner but does not add initial defualt as Local/Dim
'Raw As int a -> int a;
'Local As int a -> int a={0}
'Global adds static: Global As int a -> static int a;
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT" 
$ONEXIT "VS12.BAT $FILE$ -m64 gui release GDImage64.lib"

$HEADER
	#include <time.h>
	#include <gl/GL.h>
	#include <Uxtheme.h>
	#include "GDImage.h"
	#include "WinLIFT.h"
	#include <SDKDDKVer.h>
	//<---UNICODE AWARE
	#pragma comment(linker,"\"/manifestdependency:type='win32' \
	name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
	processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
	//>---UNICODE AWARE
	#define long_proc typedef long (__stdcall *zProc)
$HEADER


$LIBRARY <opengl32.lib>

CONST _UBOUND(T) (T.size())

TYPE ZCHART
	chartnumber As long
	chartseries As long
	radius As float
	listindex AS long
End Type

CONST ClientW    = 1000
CONST ClientH    = 560

CONST ID_CTRL    = 101
CONST ID_RESET   = 102
CONST ID_LISTBOX = 103
CONST ID_STATIC  = 112
CONST GL_MULTISAMPLE_ARB = 0x809D

Raw As HWND gn_GLwnd 
Raw As float gr_Percent 
Raw As ZCHART g_Chart 

Raw As long gn_ChartCaption, gn_ChartLegend, gn_ChartSymbol
Raw As long gn_TexSpecular, gn_TexChrome, gn_TexBoing, gn_TexBubble

Raw As vector<ZGLTEXTUREX> g_mt
Raw As vector <ZCHART_PARAM> g_Graph
Raw As BYTE g_R[34]={0}, g_G[34] = {0}, g_B[34] = {0}, g_A[34] = {0}

$IPRINT_OFF
'==============================================================================
Function EXEpath() As wstring
	Local As wstring sResult
	Local As WCHAR exepath[MAX_PATH]
	If GetModuleFileName(0,exepath,sizeof(exepath)) Then
		sResult = exepath
		sResult = sResult.substr(0,sResult.rfind("\\"))
		sResult+="\\"
	End If
	Function = sResult
End Function
'==============================================================================
Function STRL(N As long) As wstring
	Local As WCHAR longstr[33]
	_ltow_s(N,longstr,10)
	Function = (WCHAR*)longstr
End Function
'==============================================================================
Function zDefaultFont() As HFONT
	static hDefault As HFONT
	If hDefault = 0 Then
		hDefault = (HFONT) GetStockObject(ANSI_VAR_FONT)
	End If
	Function = hDefault
End Function
'==============================================================================
Sub zSetCTLFont( hCtrl As HWND, hFont As HFONT)
	SendMessage(hCtrl,WM_SETFONT,(WPARAM) hFont,FALSE)
End Sub
'==============================================================================
Function zStaticCenter(sLabel As wstring, x As long, y As long, w As long, h As long, hParent As HWND, nID As long) As HWND
	Raw As HWND hCtl = CreateWindowEx(0, "STATIC", sLabel.c_str(), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, x, y, w, h, hParent, (HMENU) nID, zInstance(), NULL)
	If hCtl Then
		zSetCTLFont(hCtl, zDefaultFont())
	End If
	Function = hCtl
End Function 
'==============================================================================
'// We need this to share UseFont among procedures
Sub GlobalFont( &UseFont As ZGLFONT,RW As long)
	static WasFont As ZGLFONT
    If RW Then
    	CopyMemory(&WasFont,&UseFont,sizeof(ZGLFONT))
    End If	
    CopyMemory(&UseFont,&WasFont,sizeof(ZGLFONT))
End Sub
'==============================================================================
'// Main window minimum horizontal track size
Function MinTrackSizeW(SizeX As long) As long
	static WasSizeX As long
	If SizeX Then
		WasSizeX = SizeX
	End If
	Function = WasSizeX
End Function
'==============================================================================
'// Main window minimum vertical track size
Function MinTrackSizeH(SizeY As long) As long
	static WasSizeY As long
	If SizeY Then
		WasSizeY = SizeY
	End If
	Function = WasSizeY
End Function
'==============================================================================
Sub ListDeleteAll(hList AS HWND)
	If hList Then
		SendMessage(hList, LB_RESETCONTENT, 0, 0)
	End If
End Sub
'==============================================================================
Function ListAdd(hList As HWND, zTmp As WCHAR Ptr) As LRESULT
	Local As LRESULT nIndex
	If hList Then
		If wcslen(zTmp) Then
			nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp)
		End If
	End If
	Function = nIndex
End Function
'==============================================================================
Sub ListSelectPlus(hList AS HWND, nIndex As long)
	If nIndex < 0 Then
		hList = 0
	End If
	If hList Then
		If nIndex > 0 Then
			--nIndex			'// Because ListBox is zero based
		End If
		SendMessage(hList, LB_SETCURSEL, nIndex, 0)
	End If
End Sub
'==============================================================================
Function ListGetCursel(hList As HWND) As LRESULT
	Local As LRESULT nIndex
	If hList Then
		nIndex = SendMessage(hList, LB_GETCURSEL, 0, 0)
		If nIndex > -1 Then
			++nIndex			'// Because ListBox is zero based
		End If
	End If
	Function = nIndex
End Function
'==============================================================================
Function ListGetText(hList As HWND, nItem As long) As wstring
	Local sData As wstring
	If nItem > 0 Then
		--nItem
		Raw As long nLen = (long) SendMessage(hList, LB_GETTEXTLEN, nItem, 0) + 1
		Raw As WCHAR Ptr szData = new WCHAR[nLen]
		memset(szData, 0, sizeof(WCHAR) * nLen)
		nLen = (long) SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData)
		sData = szData
		delete [] szData
	End If
	Function = sData
End Function
'==============================================================================
Sub gl_LoadTexture(hList As HWND)
	If hList = 0 Then
		Exit Sub
	End If
	Local As WIN32_FIND_DATAW fd
	Local As WCHAR zTmp[MAX_PATH],zExt[8]
	Local As wstring sExt
	
	ListDeleteAll(hList)
	
	Raw As wstring sImage = ".jpg.png.bmp.", sSearch = EXEpath()
	sSearch += "Spec*.jpg"
	wcscpy_s(zTmp, (WCHAR*) sSearch.c_str())
	Raw As HANDLE hFind = FindFirstFile(zTmp, &fd)
	Local As long nPos, nCount
	If hFind <> INVALID_HANDLE_VALUE Then
		Raw As int IsOk = -1
		While IsOk 
			If NOT (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) Then
            	sSearch = fd.cFileName
            	wcscpy_s(zTmp, (WCHAR*) sSearch.c_str())
            	nPos = (long) sSearch.find_last_of(".") '// Extract extension.
                sExt = sSearch.substr(nPos)
                sExt += "."
                wcscpy_s(zExt, (WCHAR*) sExt.c_str())
                CharLower(zExt)
                nPos = (long) sImage.find(zExt)
				If nPos > -1 Then
					If ListAdd(hList,zTmp) > -1 Then
						nCount += 1
					End If
				End If
			End If
			If FindNextFile(hFind, &fd) = _false Then
				IsOk = 0
			End If
		Wend
		FindClose(hFind)
	End If
	If nCount > 0 Then
		ListSelectPlus(hList, 1)	
	End If
End Sub
'==============================================================================
Sub gl_InitGraph()
	Raw As long nChartSeries = 7, nChartNumber = 7
	 
 '// The ChartSeries and ChartNumber maximum are 12 each.
    g_Chart.chartseries = min(nChartSeries, 13)
    g_Chart.chartnumber = min(nChartNumber, 13)
    g_Chart.radius = 1.0f
	
	Raw As float tabZ[13] = {-24.0f,-26.0f,-28.0f,-30.0f,-34.0f,-38.0f,-42.0f,-47.0f,-50.0f,-53.0f,-57.0f,-60.0f,-62.0f} 
	Raw As float tabY[13] = {-3.0f,-2.2f,-0.5f,0.6f,1.5f,2.5f,3.5f,4.0f,5.0f,6.5f,7.0f,8.3f,9.5f}
	Raw As long nChartMax = max(g_Chart.chartseries, g_Chart.chartnumber)
	Raw As long nChartMin = min(g_Chart.chartseries, g_Chart.chartnumber)
	
	Raw As float rChartXoff = (-g_Chart.chartseries + g_Chart.chartnumber) * 0.8333f
    Raw As float rChartYoff = tabY[nChartMin-1]
    Raw As float rChartZoff = tabZ[nChartMax-1]
    Raw As float rChartZoom = 1.0f

    Raw As float rChartXrot = 45.0f
    Raw As float rChartYrot = -25.0f
    GL_ChartSetMousing(rChartXoff, rChartYoff, rChartZoff, rChartZoom, rChartXrot, rChartYrot)
    gr_Percent = 0
	
End Sub
'==============================================================================
Sub gl_ColorInit()
	$CCODE
    g_R[33] = 32;  g_G[33] = 32;  g_B[33] = 32;  g_A[33] = 255;
    g_R[32] = 0;   g_G[32] = 44;  g_B[32] = 233; g_A[32] = 255;
    g_R[31] = 0;   g_G[31] = 67;  g_B[31] = 210; g_A[31] = 255;
    g_R[30] = 0;   g_G[30] = 89;  g_B[30] = 187; g_A[30] = 255;
    g_R[29] = 0;   g_G[29] = 112; g_B[29] = 164; g_A[29] = 255;
    g_R[28] = 0;   g_G[28] = 135; g_B[28] = 142; g_A[28] = 255;
    g_R[27] = 0;   g_G[27] = 159; g_B[27] = 117; g_A[27] = 255;
    g_R[26] = 0;   g_G[26] = 183; g_B[26] = 88;  g_A[26] = 255;
    g_R[25] = 0;   g_G[25] = 207; g_B[25] = 58;  g_A[25] = 255;
    g_R[24] = 0;   g_G[24] = 231; g_B[24] = 29;  g_A[24] = 255;
    g_R[23] = 26;  g_G[23] = 234; g_B[23] = 26;  g_A[23] = 255;
    g_R[22] = 52;  g_G[22] = 237; g_B[22] = 23;  g_A[22] = 255;
    g_R[21] = 79;  g_G[21] = 240; g_B[21] = 20;  g_A[21] = 255;
    g_R[20] = 105; g_G[20] = 243; g_B[20] = 17;  g_A[20] = 255;
    g_R[19] = 126; g_G[19] = 245; g_B[19] = 14;  g_A[19] = 255;
    g_R[18] = 147; g_G[18] = 248; g_B[18] = 11;  g_A[18] = 255;
    g_R[17] = 168; g_G[17] = 250; g_B[17] = 8;   g_A[17] = 255;
    g_R[16] = 189; g_G[16] = 253; g_B[16] = 5;   g_A[16] = 255;
    g_R[15] = 210; g_G[15] = 255; g_B[15] = 2;   g_A[15] = 255;
    g_R[14] = 233; g_G[14] = 255; g_B[14] = 0;   g_A[14] = 255;
    g_R[13] = 255; g_G[13] = 255; g_B[13] = 0;   g_A[13] = 255;
    g_R[12] = 255; g_G[12] = 251; g_B[12] = 0;   g_A[12] = 255;
    g_R[11] = 255; g_G[11] = 235; g_B[11] = 0;   g_A[11] = 255;
    g_R[10] = 255; g_G[10] = 215; g_B[10] = 0;   g_A[10] = 255;
    g_R[9]  = 255;  g_G[9] = 196;  g_B[9] = 0;    g_A[9] = 255;
    g_R[8]  = 255;  g_G[8] = 176;  g_B[8] = 0;    g_A[8] = 255;
    g_R[7]  = 255;  g_G[7] = 156;  g_B[7] = 0;    g_A[7] = 255;
    g_R[6]  = 253;  g_G[6] = 137;  g_B[6] = 0;    g_A[6] = 255;
    g_R[5]  = 255;  g_G[5] = 117;  g_B[5] = 0;    g_A[5] = 255;
    g_R[4]  = 255;  g_G[4] = 97;   g_B[4] = 0;    g_A[4] = 255;
    g_R[3]  = 255;  g_G[3] = 78;   g_B[3] = 0;    g_A[3] = 255;
    g_R[2]  = 255;  g_G[2] = 58;   g_B[2] = 0;    g_A[2] = 255;
    g_R[1]  = 255;  g_G[1] = 0;    g_B[1] = 0;    g_A[1] = 255;	
	$CCODE
End Sub
'==============================================================================
Sub gl_Initialize()

	srand((unsigned) time(NULL))

    glClearColor(0.5f, 0.5f, 0.5f, 1.0f) '// Grayed background, same as RGB(128,128,128)
    glClearDepth(1)
    glDepthFunc(GL_LESS)
    glEnable(GL_DEPTH_TEST)

    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST) '// GL_NICEST)

    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
    glEnable(GL_BLEND)
    glEnable(GL_LINE_SMOOTH)
    glShadeModel(GL_SMOOTH)
	
	'// Ambience setting.
    Raw As float LightDiffuse[4] = {0.4f, 0.4f, 0.4f, 1.0f}
    Raw As float LightAmbient[4] = {0.5f, 0.5f, 0.5f, 1.0f}
    Raw As float LightPosition[4] = {-100.0f, -100.0f, 400.0f, 1.0f}
    glLightfv(GL_LIGHT0, GL_DIFFUSE, &LightDiffuse[0])        '// Setup the Diffuse Light
    glLightfv(GL_LIGHT0, GL_AMBIENT, &LightAmbient[0])        '// Setup the Ambient Light
    glLightfv(GL_LIGHT0, GL_POSITION, &LightPosition[0])      '// Position the Light
    glMaterialfv(GL_FRONT, GL_SPECULAR, &LightDiffuse[0])
	Raw As float rFloat = 1.0f 
	glMaterialfv(GL_FRONT, GL_SHININESS, &rFloat)
	
    glEnable(GL_LIGHT0)                                      '// Enable Light ONE
    glEnable(GL_LIGHTING)                                   ' // Enable Lighting
    glEnable(GL_COLOR_MATERIAL)                             ' // Enable Coloring Of Material
    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE)

    glEnable(GL_TEXTURE_2D)
	
	Raw As long nK = 0, nI = 0, nJ = 0, nC = 0, nT = 0
	
    gl_InitGraph()

    g_Chart.listindex = 1
    glGenLists(1)

    '// Draw the XYZ axis grid.
    glNewList(g_Chart.listindex, GL_COMPILE)
       glColor4ub(255, 255, 255, 64)
       GL_ChartAxis(g_Chart.chartseries * (g_Chart.radius * 2.1f) + g_Chart.radius, 10.0f, g_Chart.chartnumber * (g_Chart.radius * 2.1f) + g_Chart.radius)
    glEndList()

    g_Graph.resize((g_Chart.chartnumber + 1) * (g_Chart.chartseries + 1))

    gl_ColorInit()
	
	'// Draw g_Chart series.
	xFor nI = 1 While nI <= g_Chart.chartnumber By nI++
        '// Setup color indice
        nC = (nC + 3) % 32 + 1
        xFor nJ = 1 While nJ <= g_Chart.chartseries By nJ++
            nK += 1
            g_Graph[nK].nList = g_Chart.listindex + nK
            g_Graph[nK].nColor = nC

            g_Graph[nK].rValue = (float) (rand() % 8 + 1) // RND(1,8)

            glNewList(g_Graph[nK].nList, GL_COMPILE)

            nT = nI
            If nT > CHART_MAX Then
            	 nT = nI % CHART_MAX
            End If 
            $CCODE
               switch (nT) {
               case CHART_BAR:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartBar(g_Chart.radius * 0.75f, g_Chart.radius * 0.75f, g_Graph[nK].rValue);
                    break;

               case CHART_CYLINDER:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartCylinder(g_Chart.radius * 0.75f, g_Graph[nK].rValue, 32, 1);
                    break;

               case CHART_PYRAMIDE:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartPyramide (g_Chart.radius * 0.75f, g_Graph[nK].rValue);
                    break;

               case CHART_SPHERE:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexBoing;
                    g_Graph[nK].nTexSpec = FALSE;
                    GL_ChartSphere(g_Chart.radius * 0.75f, g_Graph[nK].rValue, FALSE);
                    break;

               case CHART_CONE:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartCone(g_Chart.radius * 0.75f, g_Graph[nK].rValue, 32, 1);
                    break;

               case CHART_POINT:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexBubble;
                    g_Graph[nK].nTexSpec = FALSE;
                    // ChartPoint is 2D surface, thus because of billboarding
                    // we couldn't compile it with the other 3D objects.
                    //GL_ChartPoint(g_Chart.radius * 0.75f, g_Graph[nK].rValue)
                    break;
               }
            $CCODE  
            glEndList()         
        xNext
	xNext
End Sub
'==============================================================================
Sub gl_DestroyTexture()
	Local As long K, OkDelete
	Raw As long mtCount = (long) _UBOUND(g_mt)
	If mtCount Then
		Raw As long Ptr Texture = new long[mtCount]
		memset(Texture,0,mtCount)
		xFor K = 0 While K < mtCount By K++
			Texture[K] = g_mt[K].Texture
			If Texture[K] Then
				OkDelete = -1
			End If
		xNext
		If OkDelete Then
			glDeleteTextures(mtCount, (GLuint*) Texture[0])
		End If
		delete [] Texture
	End If
End Sub
'==============================================================================
Sub gl_DisableAmbience()
    glDisable(GL_LIGHT0)        '// Disable Light ONE
    glDisable(GL_LIGHTING)      '// Disable Lighting
    glDisable(GL_COLOR_MATERIAL)'// Disable Coloring of Material
End Sub
'==============================================================================
Sub gl_EnableAmbience()
    glEnable(GL_LIGHT0)         '// Enable Light ONE
    glEnable(GL_LIGHTING)       '// Enable Lighting
    glEnable(GL_COLOR_MATERIAL) '// Enable Coloring of Material
End Sub
'==============================================================================
'// This is the place where to customize the charting graph.
Sub gl_DrawScene()
	Local As long nK, nI, nJ, nC
	Local As float  rX, rY, rZ, rHalfRadius, rChartXoff, rChartYoff, rChartZoff, rChartZoom, rChartXrot, rChartYrot
	Local As WCHAR zTitle[64]
	Raw As wstring ws
	
	static nAngle As long
	nAngle += 1
	nAngle = nAngle % 360
	If gr_Percent < 1 Then
		gr_Percent += 0.002f
	End If
	
	static nFlip As long
	nFlip =  NOT nFlip
	If nFlip Then
		Exit Sub
	End If
	
	'// Turn on antialiasing
	If GL_MultiSampleARB() Then
		glEnable(GL_MULTISAMPLE_ARB)
	End If
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	
	glLoadIdentity()
	
	'// Draw image background
    gl_DisableAmbience()
       glColor4ub(255,255,255,255)
       GL_BindTexture(GL_TEXTURE_2D, gn_TexSpecular)
       GL_DrawQuad(84.0f, 42.0f, -99.99f)
    gl_EnableAmbience()
	
    '// Get Mousing coordinates, zooming, rotation.
    GL_ChartGetMousing(rChartXoff, rChartYoff, rChartZoff, rChartZoom, rChartXrot, rChartYrot)
    glTranslatef(rChartXoff, rChartYoff, rChartZoff)
	
    '// Zooming factor.
    glScalef(rChartZoom, rChartZoom, rChartZoom)
    '// Mousing rotation
    glRotatef(-rChartYrot, 1, 0, 0)
    glRotatef(-rChartXrot, 0, 1, 0)
    
    '// Retrieve current WGL font
    Raw As ZGLFONT UseFont = {0}
    Raw As WCHAR zTxt[16] = {0}
    GlobalFont(UseFont, 0)

    '// Draw the chart
    glPushMatrix()
    
		'// Use chrome texture to draw the chart graph.	
		GL_BindTexture(GL_TEXTURE_2D, gn_TexChrome)
		rHalfRadius = g_Chart.radius * 0.5f
		glTranslatef(g_Chart.radius + rHalfRadius, 0.0f, g_Chart.radius + rHalfRadius)
		nK = 0
		xFor nI = 1 While nI <= g_Chart.chartnumber By nI++
           '// Set color for the chart serie
           '//ZI_glColor4f(g_Graph[nI].nColor)
			xFor nJ = 1 While nJ <= g_Chart.chartseries By nJ++
				nK += 1
				nC = g_Graph[nK].nColor
				glColor4ub(g_R[nC], g_G[nC], g_B[nC], g_A[nC])
				GL_BindTexture(GL_TEXTURE_2D, g_Graph[nK].nTexture)
				GL_TexSpec(g_Graph[nK].nTexSpec)
               	'// Draw the matching chart item
               	If gr_Percent < 1 Then
               		$CCODE
					switch (g_Graph[nK].nType) {
					case CHART_BAR:
					   GL_ChartBar(g_Chart.radius * 0.75f, g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent);
					   break;
					case CHART_CYLINDER:
					   GL_ChartCylinder(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent, 32, 1);
					   break;
					case CHART_PYRAMIDE:
					   GL_ChartPyramide(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent);
					   break;
					case CHART_SPHERE:
					   GL_ChartSphere(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent, FALSE);
					   break;
					case CHART_CONE:
					   GL_ChartCone(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent, 32, 1);
					   break;
					case CHART_POINT:
					   GL_ChartPoint(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent);
					   break;
					}
               		
               		$CCODE
               	Else
               		If g_Graph[nK].nType = CHART_POINT Then
               			GL_ChartPoint(g_Chart.radius * 0.75f, g_Graph[nK].rValue)
               		Else
               			glCallList(g_Graph[nK].nList)
               		End If	
               	End If	
				GL_TexSpec(FALSE)
               	glTranslatef(2.1f * g_Chart.radius, 0.0f, 0.0f)
			xNext
			glTranslatef((-2.1f * g_Chart.radius) * g_Chart.chartseries, 0.0f, 2.1f * g_Chart.radius) 
		xNext	
		
		glPopMatrix()
    '// Restore the default background texture.
    GL_BindTexture(GL_TEXTURE_2D, gn_TexSpecular)
		
	'// Draw XYZ text.
	xFor nI = 0 While nI < 11 By nI++
        wcscpy_s(zTxt, (WCHAR*) STRL(nI * 10).c_str())
        GL_DrawText (gn_GLwnd, UseFont, g_Chart.chartseries * (g_Chart.radius * 2.1f) + g_Chart.radius - 0.1f, (float) nI, 0, zTxt, ZD_ARGB(255, 0,255,0))
        GL_DrawText (gn_GLwnd, UseFont, 0.1f, (float) nI, g_Chart.chartnumber * (g_Chart.radius * 2.1f) + g_Chart.radius + 0.5f, zTxt, ZD_ARGB(255, 0,255,0))
	xNext 
    
    '// Draw the XYZ grid
    glLineWidth(1.0f)
    glCallList(g_Chart.listindex)

    '// Draw the podium
    glPushMatrix()
       GL_TexSpec(TRUE)
          glColor4ub(255,255,255, 128)
          rX = g_Chart.chartseries * (g_Chart.radius * 1.05f)
          rY = g_Chart.chartnumber * (g_Chart.radius * 1.05f)
          rZ = 0
          glTranslatef(rX + g_Chart.radius * 0.5f, -0.1f, rY + g_Chart.radius * 0.5f)
          GL_ChartBar(rX + g_Chart.radius * 1.5f, rY + g_Chart.radius * 1.5f, -0.2f)
       GL_TexSpec(FALSE)
    glPopMatrix()

    '// Draw XYZ translucent glass panels
    GL_TexSpec(TRUE)
       rX = g_Chart.chartseries * (g_Chart.radius * 2.1f) + g_Chart.radius
       rY = 10
       rZ = g_Chart.chartnumber * (g_Chart.radius * 2.1f) + g_Chart.radius
       glColor4ub(240,240,255, 64) '// Transparent light blue color.
       GL_ChartAxisPanel(rX, rY, rZ)
    GL_TexSpec(FALSE)

    '// Draw legend using GDImage bitmapped font.
    glPushMatrix();
       gl_DisableAmbience();
       glColor4ub(255,255,255,255)
	   xFor nI = 1 While nI <= g_Chart.chartnumber By nI++
           glPushMatrix()
              glTranslatef((2.1f * g_Chart.radius) * g_Chart.chartseries + g_Chart.radius, rHalfRadius * 0.6f, g_Chart.radius + rHalfRadius * 1.25f)

              '// Billboard to keep it in front of the camera.
              GL_BillBoard()
              ws = (WCHAR) 128 + (WCHAR) nI
              GL_ChartSymbol(gn_GLwnd, gn_ChartSymbol, 0, 0, 0, (WCHAR*) ws.c_str())

           glPopMatrix()
           glTranslatef(0, 0, 2.1f * g_Chart.radius)
	   xNext
       gl_EnableAmbience()
    glPopMatrix()


    '// Draw small letters in front of each chart bar.
    glPushMatrix()
       gl_DisableAmbience()
       glColor4ub(255,255,255, 255)
       glTranslatef(g_Chart.radius + rHalfRadius * 0.5f, 0.0f, 2.1f * g_Chart.radius * g_Chart.chartnumber + rHalfRadius)
	   xFor nJ = 1 While nJ <= g_Chart.chartseries By nJ++
           ws = (WCHAR) 64 + (WCHAR) nJ
           GL_ChartLabel(gn_GLwnd, gn_ChartLegend, 0, 0, 0, (WCHAR*) ws.c_str())
           glTranslatef(2.1f * g_Chart.radius, 0.0f, 0.0f)
	   xNext
       glTranslatef((-2.1f * g_Chart.radius) * g_Chart.chartseries, 0.0f, 2.1f * g_Chart.radius)
       gl_EnableAmbience()
    glPopMatrix()

    '// Draw label using GDImage bitmapped font.
    glPushMatrix()
       glTranslatef(9.2f, 0.0f, 2.1f * g_Chart.radius * g_Chart.chartnumber + rHalfRadius * 3.0f + 0.35f)
       glRotatef(-90, 1, 0, 0)
       glColor4ub(255,255,0, 255)
       ws = "GDImage " 
       ws += ZI_Version()
       GL_ChartLabel(gn_GLwnd, gn_ChartCaption, 0, 0, 0, (WCHAR*) ws.c_str())
    glPopMatrix()
    

    '// Draw the chart caption using GDImage bitmapped font.
    glPushMatrix()
       glLoadIdentity()
       gl_DisableAmbience()
       glDisable(GL_DEPTH_TEST) '// We want to keep it in front.
       wcscpy_s(zTitle, "The title of the chart")
       glTranslatef(GL_ChartGetTextLength(gn_ChartCaption, zTitle) * -0.5f, -8.0f, -20.0f)
       glColor4ub(255,0,0, 255)
       GL_ChartLabel(gn_GLwnd, gn_ChartCaption, 0, 0, 0, zTitle)
       glEnable(GL_DEPTH_TEST) '// Don't forget to re-enable DEPTH_TEST
       gl_EnableAmbience()
    glPopMatrix()
    


    '// Draw zoom percentage
    ws = "Zoom "
    ws += STRL((long) (rChartZoom * 100))
    ws += " %"
    ZI_DrawGLText(gn_GLwnd, UseFont, 10, 10 + UseFont.fontHeight * 0, (WCHAR*) ws.c_str(), ZD_ARGB(255, 255,255,0))

    glFlush()

    '// Turn off antialiasing
    If GL_MultiSampleARB() Then
    	 glDisable(GL_MULTISAMPLE_ARB)
    End If

    '// Update display
    ZI_UpdateGLWindow(gn_GLwnd)
	   	    	    
End Sub
'==============================================================================
Function WndProc(hWin As HWND,uMsg As UINT,wParam As WPARAM,lParam As LPARAM) As LRESULT CALLBACK
	Raw As HWND hCtrl
	Raw As long wmId, wmEvent
	Raw As MINMAXINFO Ptr pMM
	Raw As wstring ws

	$CCODE
    switch (uMsg) {

    case WM_GETMINMAXINFO:
         pMM = (MINMAXINFO*) lParam;
         pMM->ptMinTrackSize.x = MinTrackSizeW(0);
         pMM->ptMinTrackSize.y = MinTrackSizeH(0);
         break;

    case WM_TIMER:
         gl_DrawScene();
         return 0;

    case WM_MOUSEWHEEL:
         if (GetFocus() != gn_GLwnd) { SetFocus(gn_GLwnd); }
         break;

    case WM_SIZE:
         ZI_ResizeGLWindow(gn_GLwnd);
         gl_DrawScene();
         break;

    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);

         switch (wmId) {

         case ID_RESET:
              gl_InitGraph();
              ZI_ResizeGLWindow(gn_GLwnd);
              gl_DrawScene();
              break;

         case ID_LISTBOX:
              if (wmEvent == LBN_SELCHANGE) {
                  hCtrl = GetDlgItem(hWin, ID_LISTBOX);
                  ws = EXEpath(); ws += ListGetText(hCtrl, (long) ListGetCursel(hCtrl));
                  wcscpy_s(g_mt[0].FullName, (WCHAR*) ws.c_str());
                  ZI_UpdateNamedGLTextureFromFileEx(g_mt[0].FullName, g_mt[0].Texture, g_mt[0].Square);
              }
              break;
         }
         return 0;

    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;
    }
    return DefWindowProc(hWin, uMsg, wParam, lParam);
	
	$CCODE
End Function
Function WinMain

    UNREFERENCED_PARAMETER(hPrev)
    UNREFERENCED_PARAMETER(CmdLine)
    
    Raw As MSG msg
    Local As long nRet
    Local As WNDCLASSEX wcx
    Raw As WCHAR szWindowClass[] = "ZCHART3D" 
    
	Raw As RECT rc
	Raw As long x, y, IsInitialized
	Raw As DWORD dwStyle, dwExStyle
	Raw As HWND hMain, hList, hFound
	
	Local As ZGLFONT UseFont
	
	Raw As HANDLE hMutex = CreateMutex(NULL, 0, szWindowClass)  
	If hMutex Then
		If GetLastError() = ERROR_ALREADY_EXISTS Then
			Do
				hFound = FindWindow(szWindowClass, NULL)
				If (hFound) Then
					break
				End If
				while (PeekMessage(&msg, NULL, NULL, NULL, PM_REMOVE))
					
				Wend
			Loop
			If IsIconic(hFound) Then
				ShowWindow(hFound, SW_RESTORE)
			End If
			SetForegroundWindow(hFound)
			Function = 0
		End If	
	End If

    wcx.cbSize = sizeof(wcx)
    IsInitialized = GetClassInfoEx(hInst, szWindowClass, &wcx)
    
    If NOT IsInitialized Then
		wcx.style         = CS_HREDRAW | CS_VREDRAW
		wcx.lpfnWndProc   = WndProc
		wcx.cbClsExtra    = 0
		wcx.cbWndExtra    = 0
		wcx.hInstance     = hInst
		wcx.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(IDI_APPLICATION))
		wcx.hCursor       = LoadCursor(NULL, IDC_ARROW)
		wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1)
		wcx.lpszMenuName  = NULL
		wcx.lpszClassName = szWindowClass
		wcx.hIconSm       = wcx.hIcon
    	If RegisterClassEx(&wcx) Then
    		IsInitialized = -1
    	End If
    End If

	If IsInitialized Then
		'// Window Extended Style
		dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE
		'// Windows Style
		dwStyle = WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN
		SetRect(&rc, 0, 0, ClientW, ClientH)
		AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle)    '// Adjust Window To True Requested Size
		
		x = max((GetSystemMetrics(SM_CXSCREEN) - rc.right - rc.left) / 2, 0)
		y = max((GetSystemMetrics(SM_CYSCREEN) - rc.bottom - rc.top) / 2, 0)
		MinTrackSizeW(rc.right - rc.left)
		MinTrackSizeH(rc.bottom - rc.top)
		
		'// Create The Window
		Raw As wstring sCaption = "GDImage "
		sCaption += ZI_Version()
		If sizeof(LONG_PTR) = 8 Then
			sCaption +=" 64-bit"
		Else
			sCaption +=" 32-bit"
		End If
		sCaption +=	", 3D Chart demo"	
	 
		hMain = CreateWindowEx( dwExStyle, _                  '// Extended Style For The Window
								szWindowClass, _              '// Class Name
								(WCHAR*) sCaption.c_str(), _  '// Window Title
								dwStyle, _                    '// Defined Window Style
								x, y, _                       '// Window Position
								MinTrackSizeW(0), _           '// Calculate Window Width 
								MinTrackSizeH(0), _           '// Calculate Window Height
								NULL, _                       '// No Parent Window
								NULL, _                       '// No Menu
								hInst, _                  '    // Instance
								NULL)                         '// Dont Pass Anything To WM_CREATE
	
	
	
	
		If hMain Then
        	'// Create button "Reset"
        	CreateWindowEx(0, "BUTTON", "Reset", WS_CHILD | WS_VISIBLE | WS_TABSTOP, _ 
                             ClientW - (7 + 120 + 8), 10 + (22 + 5) * 2 - 2, 120, 30, hMain, (HMENU) ID_RESET, hInst, NULL)
			zSetCTLFont(GetDlgItem(hMain, ID_RESET), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hMain, ID_RESET), ANCHOR_RIGHT)

			'// Create Static.
			zStaticCenter("\rLeft mouse button:\rchange view angle.\rRight mouse button:\rchange graph location.\r\rMouse wheel zooming.", _ 
			              ClientW - (7 + 120 + 8), 10 + (22 + 5) * 5 + 5, 120, 120, hMain, ID_STATIC)
			ZI_SetAnchorMode(GetDlgItem(hMain, ID_STATIC), ANCHOR_RIGHT)
			
			'// Create ListBox to select texture from.
			hList = CreateWindowEx(0, "ListBox", NULL, WS_CHILD | WS_BORDER | WS_VISIBLE | WS_VSCROLL | LBS_SORT | LBS_NOTIFY | LBS_HASSTRINGS | LBS_DISABLENOSCROLL, _
			                       ClientW - (7 + 120 + 8), 10 + (22 + 5) * 10 + 5, 120, 120, hMain, (HMENU) ID_LISTBOX, hInst, NULL)
			ZI_SetAnchorMode(hList, ANCHOR_RIGHT)
			zSetCTLFont(hList, zDefaultFont())
			gl_LoadTexture(hList)

			'// *******************************************************************************
			'// Alternate methode to create a GDImage OpenGL control
			'// Note: when GDImage is active the OpenGL $GLImageClassName is already registered
			'// -------------------------------------------------------------------------------
			'// 6.04 Create antialiased control.
			dwStyle = WS_CHILD | WS_VISIBLE
			dwExStyle = 0
			gn_GLwnd = WGL_CreateWindow(dwExStyle, dwStyle, 0, 0, 844, ClientH, hMain, (HMENU) ID_CTRL)
			
			If gn_GLwnd Then
				ZI_SetAnchorMode(gn_GLwnd, ANCHOR_HEIGHT_WIDTH)    '// Anchor the control (make it a resizable)	
				
				'// Use GDImage OpenGL automatic mousing support.
				GL_UseMouseManager(gn_GLwnd)
				
				'// Create the textures.
				g_mt.resize(4)
				Raw As wstring ws = EXEpath()
				ws += ListGetText(hList, (long) ListGetCursel(hList))
				wcscpy_s(g_mt[0].FullName, (WCHAR*) ws.c_str())
				g_mt[0].ID = 1
				g_mt[0].Square = 0
				
				ws = EXEpath()
				ws += "chrome.jpg"
				wcscpy_s(g_mt[1].FullName, (WCHAR*) ws.c_str())
				g_mt[1].ID = 2
				g_mt[1].Square = 0
				
'***********************************************************************				
'While bc9Basic will allow the following line I have NEVER used multiple statements on a sinle line in any language
'ws = EXEpath(); ws += "boing.png";  wcscpy_s(g_mt[2].FullName, (WCHAR*) ws.c_str()); g_mt[2].ID = 3; g_mt[2].Square = 0;
'***********************************************************************				
				ws = EXEpath()
				ws += "boing.png"
				wcscpy_s(g_mt[2].FullName, (WCHAR*) ws.c_str())
				g_mt[2].ID = 3
				g_mt[2].Square = 0
				
				ws = EXEpath()
				ws += "bubble.png"
				wcscpy_s(g_mt[3].FullName, (WCHAR*) ws.c_str())
				g_mt[3].ID = 4
				g_mt[3].Square = 0
				
				ZI_MakeMultipleTexture(&g_mt[0], (long) _UBOUND(g_mt))
				gn_TexSpecular = g_mt[0].Texture
				gn_TexChrome   = g_mt[1].Texture
				gn_TexBoing    = g_mt[2].Texture
				gn_TexBubble   = g_mt[3].Texture
				
				gl_Initialize()
	
				'// Create a WGL font for the XYZ axis.
				ZI_BuildGLfont(ZI_GetGLDC(gn_GLwnd), UseFont)  '// Build OpenGL font for our OpenGL window
				GlobalFont(UseFont, 1)
				
				'// Create a GDImage bitmapped font for the chart labels.
				'// Valid font size are: 16,32,64
				gn_ChartCaption = GL_CreateFontTexture(gn_GLwnd, "TREBUCHET MS", 32, 0xFFFFFFFF)
				gn_ChartSymbol  = GL_CreateFontTexture(gn_GLwnd, "WINGDINGS", 32, 0xFFFFFFFF)
				gn_ChartLegend  = GL_CreateFontTexture(gn_GLwnd, "TREBUCHET MS", 16, 0xFFFFFFFF)
				
				'// Show the main window
				ShowWindow(hMain, CmdShow)
				SetForegroundWindow(hMain)                  '// Slightly Higher Priority
				SetFocus(hMain)                             '// Sets Keyboard Focus To The Window

				'// Main message pump.
				SetTimer(hMain, 1, 0, 0)   '// 66 FPS
				While GetMessage(&msg, NULL, 0, 0) 
				   TranslateMessage(&msg)
				   DispatchMessage(&msg)
				Wend

				nRet = (long) msg.wParam
				KillTimer(hMain, 1)
				
				'// Cleanup texture from memory
				gl_DestroyTexture()
				'// Delete GLFont.
				ZI_DeleteGLFont(UseFont)


							
			End If
			
		End If
	
	End If
	
	If hMutex Then
		CloseHandle(hMutex)
	End If
	
	Function = nRet
	
End Function
